import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopMerchantAccount, ShopMerchantAccountParam } from './model';

/**
 * 分页查询商户账号
 */
export async function pageShopMerchantAccount(params: ShopMerchantAccountParam) {
  const res = await request.get<ApiResult<PageResult<ShopMerchantAccount>>>(
    '/shop/shop-merchant-account/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商户账号列表
 */
export async function listShopMerchantAccount(params?: ShopMerchantAccountParam) {
  const res = await request.get<ApiResult<ShopMerchantAccount[]>>(
    '/shop/shop-merchant-account',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商户账号
 */
export async function addShopMerchantAccount(data: ShopMerchantAccount) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-merchant-account',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商户账号
 */
export async function updateShopMerchantAccount(data: ShopMerchantAccount) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-merchant-account',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商户账号
 */
export async function removeShopMerchantAccount(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant-account/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商户账号
 */
export async function removeBatchShopMerchantAccount(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant-account/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商户账号
 */
export async function getShopMerchantAccount(id: number) {
  const res = await request.get<ApiResult<ShopMerchantAccount>>(
    '/shop/shop-merchant-account/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
